;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_tr_env
  (foreign (include #"caml-bigloo.h"))
  (import
    (__caml_misc #"misc.scm")
    (__caml_syntax #"syntax.scm")
    (__caml_ty_error #"ty_error.scm")
    (__caml_globals #"globals.scm")
    (__caml_prim #"prim.scm")
    (__caml_lambda #"lambda.scm")
    (__caml_const #"const.scm"))
  (export
    (translate_path_176@tr_env x1)
    (2-149-translate_path_176@tr_env x1 x3)
    (translate_access_117@tr_env x1)
    (2-26-translate_access_117@tr_env x1 x2)
    (translate_update_202@tr_env x1)
    (3-114-translate_update_202@tr_env x1 x2 x3)
    (paths_of_pat_67@tr_env x1)
    (2-246-paths_of_pat_67@tr_env x1 x2)
    (mutable_vars_of_pat_68@tr_env x1)
    (add_lets_to_env_171@tr_env x1)
    (2-201-add_lets_to_env_171@tr_env x1 x2)
    (add_lets_to_expr_69@tr_env x1)
    (3-167-add_lets_to_expr_69@tr_env x1 x2 x3)
    (add_pat_to_env_200@tr_env x1)
    (2-244-add_pat_to_env_200@tr_env x1 x2)
    (add_pat_list_to_env_65@tr_env x1)
    (2-65-add_pat_list_to_env_65@tr_env x1 x2)
    (add_for_parameter_to_env_127@tr_env x1)
    (2-180-add_for_parameter_to_env_127@tr_env x1 x2)
    (add_let_rec_to_env_158@tr_env x1)
    (2-243-add_let_rec_to_env_158@tr_env x1 x2)
    (env_for_toplevel_let_34@tr_env x1)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(begin
  (define translate_path_176@tr_env
    (lambda (x1)
      (lambda (x3)
        (2-149-translate_path_176@tr_env x1 x3))))
 (define 2-149-translate_path_176@tr_env
    (lambda (x1 x3)
      (letrec ((x2 (lambda (x3)
                     (let ((:-d.1000 x3))
                       (cond ((eq? :-d.1000 (caml-make-tag 0 2)) x1)
                             (else
                              (caml-make-regular
                                (caml-make-tag 6 19)
                                2
                                (caml-make-regular
                                  (caml-make-tag 8 38)
                                  1
                                  (caml-constr-get-field x3 0))
                                (cons (x2 (caml-constr-get-field x3 1))
                                      '()))))))))
        (x2 x3))))
)
(begin
  (define translate_access_117@tr_env
    (lambda (x1)
      (lambda (x2)
        (2-26-translate_access_117@tr_env x1 x2))))
 (define 2-26-translate_access_117@tr_env
    (lambda (x1 x2)
      (letrec ((x3 (lambda (x4)
                     (lambda (x5)
                       (let ((:-d.1001 x5))
                         (cond ((eq? :-d.1001 (caml-make-tag 0 3))
                                (fatal_error_193@misc #"translate_env"))
                               (else
                                (case (caml-regular-constr-tag :-d.1001)
                                  ((2)
                                   ((x3 (+fx x4 1))
                                    (caml-constr-get-field x5 0)))
                                  (else
                                   (let* ((handler-top1003 current_handler)
                                          (:-d.1004 (unspecified)))
                                     (labels
                                       ((try1005
                                          (:-d.1004)
                                          (begin
                                            (get-the-continuation :-d.1004)
                                            (if (eq? #t #f)
                                              (try1005 (try1005 (try1005 1))))
                                            (if :-d.1004
                                              (let ((x6 ((assoc_252@list x1)
                                                         (caml-constr-get-field
                                                           x5
                                                           0))))
                                                ((translate_path_176@tr_env
                                                   (caml-make-regular
                                                     (caml-make-tag 0 19)
                                                     1
                                                     x4))
                                                 x6))
                                              current_handler))))
                                       (let ((x6 (try1005 :-d.1004)))
                                         (set! current_handler handler-top1003)
                                         (if (=fx *try* 1)
                                           (begin
                                             (set! *try* 0)
                                             (labels
                                               ((staticfail1006 () (raise x6)))
                                               (case (caml-extensible-constr-tag
                                                       x6)
                                                 ((not_found_4@exc)
                                                  ((x3 (+fx x4 1))
                                                   (caml-constr-get-field
                                                     x5
                                                     1)))
                                                 (else (staticfail1006)))))
                                           x6)))))))))))))
        ((x3 0) x2))))
)
(begin
  (define translate_update_202@tr_env
    (lambda (x1)
      (lambda (x2)
        (lambda (x3)
          (3-114-translate_update_202@tr_env x1 x2 x3)))))
 (define 3-114-translate_update_202@tr_env
    (lambda (x1 x2 x3)
      (letrec ((x4 (lambda (x5)
                     (lambda (x6)
                       (let ((:-d.1007 x6))
                         (cond ((eq? :-d.1007 (caml-make-tag 0 3))
                                (fatal_error_193@misc #"translate_update"))
                               (else
                                (case (caml-regular-constr-tag :-d.1007)
                                  ((2)
                                   ((x4 (+fx x5 1))
                                    (caml-constr-get-field x6 0)))
                                  (else
                                   (let* ((handler-top1009 current_handler)
                                          (:-d.1010 (unspecified)))
                                     (labels
                                       ((try1012
                                          (:-d.1010)
                                          (begin
                                            (get-the-continuation :-d.1010)
                                            (if (eq? #t #f)
                                              (try1012 (try1012 (try1012 1))))
                                            (if :-d.1010
                                              (let ((x7 ((assoc_252@list x1)
                                                         (caml-constr-get-field
                                                           x6
                                                           0))))
                                                (let ((:-d.1011 x7))
                                                  (cond ((eq? :-d.1011
                                                              (caml-make-tag
                                                                0
                                                                2))
                                                         (raise 'not_found_4@exc))
                                                        (else
                                                         (caml-make-regular
                                                           (caml-make-tag 6 19)
                                                           2
                                                           (caml-make-regular
                                                             (caml-make-tag
                                                               9
                                                               38)
                                                             1
                                                             (caml-constr-get-field
                                                               x7
                                                               0))
                                                           (cons ((translate_path_176@tr_env
                                                                    (caml-make-regular
                                                                      (caml-make-tag
                                                                        0
                                                                        19)
                                                                      1
                                                                      x5))
                                                                  (caml-constr-get-field
                                                                    x7
                                                                    1))
                                                                 (cons x3
                                                                       '())))))))
                                              current_handler))))
                                       (let ((x7 (try1012 :-d.1010)))
                                         (set! current_handler handler-top1009)
                                         (if (=fx *try* 1)
                                           (begin
                                             (set! *try* 0)
                                             (labels
                                               ((staticfail1013 () (raise x7)))
                                               (case (caml-extensible-constr-tag
                                                       x7)
                                                 ((not_found_4@exc)
                                                  ((x4 (+fx x5 1))
                                                   (caml-constr-get-field
                                                     x6
                                                     1)))
                                                 (else (staticfail1013)))))
                                           x7)))))))))))))
        ((x4 0) x2))))
)
(begin
  (define paths_of_pat_67@tr_env
    (lambda (x1)
      (lambda (x2)
        (2-246-paths_of_pat_67@tr_env x1 x2))))
 (define 2-246-paths_of_pat_67@tr_env
    (lambda (x1 x2)
      (let ((x3 (caml-constr-get-field x2 0)))
        (labels
          ((staticfail1014 () '()))
          (case (if (caml-constant-constr? x3)
                  -1
                  (caml-regular-constr-tag x3))
            ((2)
             (cons (caml-make-regular
                     (caml-make-tag 0 1)
                     2
                     (caml-constr-get-field x3 0)
                     x1)
                   '()))
            ((3)
             (cons (caml-make-regular
                     (caml-make-tag 0 1)
                     2
                     (caml-constr-get-field x3 1)
                     x1)
                   ((paths_of_pat_67@tr_env x1)
                    (caml-constr-get-field x3 0))))
            ((5)
             (letrec ((x4 (lambda (x5)
                            (lambda (x6)
                              (if (null? x6)
                                '()
                                ((@_176@list
                                   ((paths_of_pat_67@tr_env
                                      (caml-make-regular
                                        (caml-make-tag 1 2)
                                        2
                                        x5
                                        x1))
                                    (car x6)))
                                 ((x4 (+fx x5 1)) (cdr x6))))))))
               ((x4 0) (caml-constr-get-field x3 0))))
            ((6) '())
            ((7)
             (let ((x4 (caml-constr-get-field
                         (caml-constr-get-field
                           (caml-constr-get-field x3 0)
                           1)
                         4)))
               (labels
                 ((staticfail1015
                    ()
                    ((paths_of_pat_67@tr_env
                       (caml-make-regular (caml-make-tag 1 2) 2 0 x1))
                     (caml-constr-get-field x3 1))))
                 (case (if (caml-constant-constr? x4)
                         -1
                         (caml-regular-constr-tag x4))
                   ((3)
                    ((paths_of_pat_67@tr_env x1)
                     (caml-constr-get-field x3 1)))
                   (else (staticfail1015))))))
            ((9)
             ((paths_of_pat_67@tr_env x1)
              (caml-constr-get-field x3 0)))
            ((10)
             (letrec ((x4 (lambda (x5)
                            (if (null? x5)
                              '()
                              ((@_176@list
                                 ((paths_of_pat_67@tr_env
                                    (caml-make-regular
                                      (caml-make-tag 1 2)
                                      2
                                      (caml-constr-get-field
                                        (caml-constr-get-field
                                          (caml-constr-get-field (car x5) 0)
                                          1)
                                        3)
                                      x1))
                                  (caml-constr-get-field (car x5) 1)))
                               (x4 (cdr x5)))))))
               (x4 (caml-constr-get-field x3 0))))
            (else (staticfail1014)))))))
)
(define mutable_vars_of_pat_68@tr_env
  (lambda (x1)
    (let ((x2 (caml-constr-get-field x1 0)))
      (labels
        ((staticfail1016 () '()))
        (case (if (caml-constant-constr? x2)
                -1
                (caml-regular-constr-tag x2))
          ((9 3)
           (mutable_vars_of_pat_68@tr_env
             (caml-constr-get-field x2 0)))
          ((5)
           ((flat_map_45@list mutable_vars_of_pat_68@tr_env)
            (caml-constr-get-field x2 0)))
          ((7)
           (let ((x3 (caml-constr-get-field
                       (caml-constr-get-field
                         (caml-constr-get-field x2 0)
                         1)
                       2)))
             (let ((:-d.1017 x3))
               (cond ((eq? :-d.1017 (caml-make-tag 0 2))
                      (free_vars_of_pat_1@syntax
                        (caml-constr-get-field x2 1)))
                     ((eq? :-d.1017 (caml-make-tag 1 2))
                      (mutable_vars_of_pat_68@tr_env
                        (caml-constr-get-field x2 1)))
                     (else #f)))))
          ((10)
           ((flat_map_45@list
              (lambda (x3)
                (let ((x4 (caml-constr-get-field
                            (caml-constr-get-field
                              (caml-constr-get-field x3 0)
                              1)
                            2)))
                  (let ((:-d.1018 x4))
                    (cond ((eq? :-d.1018 (caml-make-tag 0 2))
                           (free_vars_of_pat_1@syntax
                             (caml-constr-get-field x3 1)))
                          ((eq? :-d.1018 (caml-make-tag 1 2))
                           (mutable_vars_of_pat_68@tr_env
                             (caml-constr-get-field x3 1)))
                          (else #f))))))
            (caml-constr-get-field x2 0)))
          (else (staticfail1016)))))))

(begin
  (define add_lets_to_env_171@tr_env
    (lambda (x1)
      (lambda (x2)
        (2-201-add_lets_to_env_171@tr_env x1 x2))))
 (define 2-201-add_lets_to_env_171@tr_env
    (lambda (x1 x2)
      (let ((x3 x1))
        (if (null? x3)
          x2
          ((add_lets_to_env_171@tr_env (cdr x3))
           (caml-make-regular
             (caml-make-tag 2 3)
             2
             (cons (caml-make-regular
                     (caml-make-tag 0 1)
                     2
                     (car x3)
                     (caml-make-tag 0 2))
                   '())
             x2))))))
)
(begin
  (define add_lets_to_expr_69@tr_env
    (lambda (x1)
      (lambda (x2)
        (lambda (x3)
          (3-167-add_lets_to_expr_69@tr_env x1 x2 x3)))))
 (define 3-167-add_lets_to_expr_69@tr_env
    (lambda (x1 x2 x3)
      (letrec ((x4 (lambda (x5)
                     (lambda (x6)
                       (if (null? x6)
                         '()
                         (cons ((translate_access_117@tr_env (car x6)) x5)
                               ((x4 (caml-make-regular
                                      (caml-make-tag 1 3)
                                      1
                                      x5))
                                (cdr x6))))))))
        (caml-make-regular
          (caml-make-tag 4 19)
          2
          ((x4 x2) x1)
          x3))))
)
(begin
  (define add_pat_to_env_200@tr_env
    (lambda (x1)
      (lambda (x2)
        (2-244-add_pat_to_env_200@tr_env x1 x2))))
 (define 2-244-add_pat_to_env_200@tr_env
    (lambda (x1 x2)
      (let ((x3 (caml-make-regular
                  (caml-make-tag 2 3)
                  2
                  ((paths_of_pat_67@tr_env (caml-make-tag 0 2)) x2)
                  x1)))
        (let ((x4 (mutable_vars_of_pat_68@tr_env x2)))
          (caml-make-regular
            (caml-make-tag 0 1)
            2
            ((add_lets_to_env_171@tr_env x4) x3)
            ((add_lets_to_expr_69@tr_env x4) x3))))))
)
(begin
  (define add_pat_list_to_env_65@tr_env
    (lambda (x1)
      (lambda (x2)
        (2-65-add_pat_list_to_env_65@tr_env x1 x2))))
 (define 2-65-add_pat_list_to_env_65@tr_env
    (lambda (x1 x2)
      (let ((x3 (((it_list_7@list
                    (lambda (x3)
                      (lambda (x4)
                        (caml-make-regular
                          (caml-make-tag 2 3)
                          2
                          ((paths_of_pat_67@tr_env (caml-make-tag 0 2)) x4)
                          x3))))
                  x1)
                 x2)))
        (let ((x4 ((flat_map_45@list mutable_vars_of_pat_68@tr_env)
                   x2)))
          (caml-make-regular
            (caml-make-tag 0 1)
            2
            ((add_lets_to_env_171@tr_env x4) x3)
            ((add_lets_to_expr_69@tr_env x4) x3))))))
)
(begin
  (define add_for_parameter_to_env_127@tr_env
    (lambda (x1)
      (lambda (x2)
        (2-180-add_for_parameter_to_env_127@tr_env x1 x2))))
 (define 2-180-add_for_parameter_to_env_127@tr_env
    (lambda (x1 x2)
      (caml-make-regular
        (caml-make-tag 1 3)
        1
        (caml-make-regular
          (caml-make-tag 2 3)
          2
          (cons (caml-make-regular
                  (caml-make-tag 0 1)
                  2
                  x2
                  (caml-make-regular
                    (caml-make-tag 1 2)
                    2
                    0
                    (caml-make-tag 0 2)))
                '())
          x1))))
)
(begin
  (define add_let_rec_to_env_158@tr_env
    (lambda (x1)
      (lambda (x2)
        (2-243-add_let_rec_to_env_158@tr_env x1 x2))))
 (define 2-243-add_let_rec_to_env_158@tr_env
    (lambda (x1 x2)
      (let ((x3 (lambda (x3)
                  (lambda (x4)
                    (let ((x5 (caml-constr-get-field
                                (caml-constr-get-field x4 0)
                                0)))
                      (labels
                        ((staticfail1019
                           ()
                           (illegal_letrec_pat_53@ty_error
                             (caml-constr-get-field
                               (caml-constr-get-field x4 0)
                               1))))
                        (case (if (caml-constant-constr? x5)
                                -1
                                (caml-regular-constr-tag x5))
                          ((2)
                           (caml-make-regular
                             (caml-make-tag 2 3)
                             2
                             (cons (caml-make-regular
                                     (caml-make-tag 0 1)
                                     2
                                     (caml-constr-get-field x5 0)
                                     (caml-make-tag 0 2))
                                   '())
                             x3))
                          (else (staticfail1019)))))))))
        (((it_list_7@list x3) x1) x2))))
)
(define env_for_toplevel_let_34@tr_env
  (lambda (x1)
    (((it_list_7@list
        (lambda (x2)
          (lambda (x3)
            (caml-make-regular
              (caml-make-tag 2 3)
              2
              ((paths_of_pat_67@tr_env (caml-make-tag 0 2)) x3)
              x2))))
      (caml-make-tag 0 3))
     x1)))

